;--------------------------------------------------------;
; File regval.asm                                        ;
; Utilizza una MessageBox per mostrare il contenuto      ;
; iniziale dei principali registri della CPU             ;
;--------------------------------------------------------;

; ################# direttive per l'assembler #################

.386                                ; set di istruzioni a 32 bit
.MODEL      FLAT, STDCALL           ; memory model & calling conventions
OPTION      CASEMAP: NONE           ; case sensitive on symbols

; ############### dichiarazione tipi e costanti ###############

NULL              = 00000000h       ; valore nullo
MB_OK             = 00000000h       ; codice bottone 'OK'
MB_ICONWARNING    = 00000030h       ; codice icona 'ICONWARNING'

; ################# prototipi delle procedure #################

GetModuleHandleA  PROTO :DWORD
wsprintfA         PROTO C :DWORD, :DWORD, :VARARG
MessageBoxA       PROTO :DWORD, :DWORD, :DWORD, :DWORD
ExitProcess       PROTO :DWORD

; #################### inclusione librerie ####################

INCLUDELIB ..\lib\user32.lib           ; libreria servizi GUI
INCLUDELIB ..\lib\kernel32.lib         ; libreria servizi kernel

; ################ segmento dati inizializzati #################

_DATA       SEGMENT  DWORD PUBLIC USE32 'DATA'

reg_CS         dd    0
reg_DS         dd    0
reg_ES         dd    0
reg_SS         dd    0
reg_FS         dd    0
reg_GS         dd    0

strTitolo      db    'Win32 Assembly', 0
strFormat      db    'Indirizzo di partenza del modulo REGVAL.EXE = %.8Xh', 10
               db    'Contenuto dei registri di segmento:', 10
               db    'CS = %.4Xh', 10
               db    'DS = %.4Xh', 10
               db    'ES = %.4Xh', 10
               db    'SS = %.4Xh', 10
               db    'FS = %.4Xh', 10
               db    'GS = %.4Xh', 10
               db    'Contenuto iniziale di ESP = %.8Xh', 0
strBuffer      db    128  dup  (0)

_DATA       ENDS

; ############## segmento dati non inizializzati ##############

_BSS        SEGMENT  DWORD PUBLIC USE32 'BSS'

hInstance      dd    ?

_BSS        ENDS

; ##################### segmento di codice #####################

_TEXT       SEGMENT DWORD PUBLIC USE32 'CODE'

start:                                 ; entry point del programma

   invoke   GetModuleHandleA, NULL     ; trova l'handle del modulo REGVAL.EXE
   mov      hInstance, eax             ; e lo salva in hInstance

   mov      word ptr reg_CS[0], cs
   mov      word ptr reg_DS[0], ds
   mov      word ptr reg_ES[0], es
   mov      word ptr reg_SS[0], ss
   mov      word ptr reg_FS[0], fs
   mov      word ptr reg_GS[0], gs
   
   invoke   wsprintfA, offset strBuffer,    
                       offset strFormat,    
                       hInstance,           
                       reg_CS,              
                       reg_DS,              
                       reg_ES,              
                       reg_SS,              
                       reg_FS,              
                       reg_GS,              
                       esp                  

   invoke   MessageBoxA, NULL, offset strBuffer, offset strTitolo, MB_OK OR MB_ICONWARNING
      
   invoke   ExitProcess, 0          ; termina con exit code = 0

_TEXT       ENDS

; ##############################################################

   END      start                   ; fine del modulo

